#include "StdInc.h"
#include "RollEm.h"

DieRoll g_drPaste;
DieRoll g_drCustom;

VoidHand hTitle;
VoidHand hNumber; 
VoidHand hDie;
VoidHand hModifier;
VoidHand hBest;
VoidHand hCompare1;
VoidHand hCompare2;
VoidHand hSuccess;

void InitializeCustom ();
void CopyCustomRoll (DieRollPtr dieRollPtr);
void PasteCustomRoll (DieRollPtr dieRollPtr);
Int CreateSoundList (CharPtr **pList);
void DeleteSoundList (CharPtr **pList);

Int SelectBeep (FormPtr pForm, Word wTriggerId, Word wListId, Int iCurrent);

Boolean CustomProc (EventPtr event)
{
    FormPtr   pForm;
    Int       handled = 0;

	pForm = FrmGetActiveForm();
    switch (event->eType) 
    {
        case frmOpenEvent:
        {
			InitializeCustom();
			GetCustomButton(&g_drCustom);
			PasteCustomRoll(&g_drCustom);

            FrmDrawForm(pForm);
            FrmSetFocus(pForm, FrmGetObjectIndex(pForm, IDC_TITLE));
            handled = 1;
            break;
        }
        case ctlSelectEvent:  // A control button was pressed and released.
            switch (event->data.ctlEnter.controlID)
            {
                case IDC_BEEP_TYPE1:
				{
					CharPtr *pList;
					int i, iCount;

					iCount = CreateSoundList (&pList);
					g_drCustom.FIELD_BEEPTYPE1 = SelectDynamicPopup (FrmGetActiveForm(), 
						IDC_BEEP_TYPE1, IDC_BEEP_LIST1, g_drCustom.FIELD_BEEPTYPE1, pList, iCount);
					DeleteSoundList(&pList);
					break;
				}
                case IDC_BEEP_TYPE2:
				{
					CharPtr *pList;
					int i, iCount;

					iCount = CreateSoundList (&pList);
					g_drCustom.FIELD_BEEPTYPE2 = SelectDynamicPopup (FrmGetActiveForm(), 
						IDC_BEEP_TYPE2, IDC_BEEP_LIST2, g_drCustom.FIELD_BEEPTYPE2, pList, iCount);
					DeleteSoundList(&pList);
					break;
				}
                case IDC_COMPARE_TYPE1:
                    g_drCustom.FIELD_BEEPCOMPARE1 = SelectPopup (FrmGetActiveForm(), 
                        IDC_COMPARE_TYPE1, IDC_COMPARE_LIST1, g_drCustom.FIELD_BEEPCOMPARE1);
                    break;
                case IDC_COMPARE_TYPE2:
                    g_drCustom.FIELD_BEEPCOMPARE2 = SelectPopup (FrmGetActiveForm(), 
                        IDC_COMPARE_TYPE2, IDC_COMPARE_LIST2, g_drCustom.FIELD_BEEPCOMPARE2);
                    break;
                case IDC_SUCCESS_TYPE:
                    g_drCustom.FIELD_SUCCESSCOMPARE = SelectPopup (FrmGetActiveForm(), 
                        IDC_SUCCESS_TYPE, IDC_SUCCESS_LIST, g_drCustom.FIELD_SUCCESSCOMPARE);
                    break;
                case IDC_OK:
                {
                    Char szMinRange [10], szMaxRange [10];

                    pForm = FrmGetActiveForm();
					CopyCustomRoll(&g_drCustom);
                    
                    // Validate all the data
                    if ((g_drCustom.FIELD_NUMBER < MIN_NUMBER) || 
                        (g_drCustom.FIELD_NUMBER > MAX_NUMBER))
                    {
                        StrLToA(szMinRange, (Long)MIN_NUMBER);
                        StrLToA(szMaxRange, (Long)MAX_NUMBER);
                        FrmCustomAlert(IDA_RANGE_ERROR, "number of dice", 
                            szMinRange, szMaxRange);
                        FrmSetFocus(pForm, FrmGetObjectIndex(pForm, IDC_NUMBER));
                        break;
                    }
                    if ((g_drCustom.FIELD_DIE < MIN_DIE) || 
                        (g_drCustom.FIELD_DIE > MAX_DIE))
                    {
                        StrLToA(szMinRange, (Long)MIN_DIE);
                        StrLToA(szMaxRange, (Long)MAX_DIE);
                        FrmCustomAlert(IDA_RANGE_ERROR, "die", 
                            szMinRange, szMaxRange);
                        FrmSetFocus(pForm, FrmGetObjectIndex(pForm, IDC_DIE));
                        break;
                    }
                    if ((g_drCustom.FIELD_MODIFIER < MIN_MODIFIER) || 
                        (g_drCustom.FIELD_MODIFIER > MAX_MODIFIER))
                    {
                        StrLToA(szMinRange, (Long)MIN_MODIFIER);
                        StrLToA(szMaxRange, (Long)MAX_MODIFIER);
                        FrmCustomAlert(IDA_RANGE_ERROR, "modifer", 
                            szMinRange, szMaxRange);
                        FrmSetFocus(pForm, FrmGetObjectIndex(pForm, IDC_MODIFIER));
                        break;
                    }
                    if ((g_drCustom.FIELD_BEST < MIN_BEST) || 
                        (g_drCustom.FIELD_BEST > MAX_BEST))
                    {
                        StrLToA(szMinRange, (Long)MIN_BEST);
                        StrLToA(szMaxRange, (Long)MAX_BEST);
                        FrmCustomAlert(IDA_RANGE_ERROR, "best", 
                            szMinRange, szMaxRange);
                        FrmSetFocus(pForm, FrmGetObjectIndex(pForm, IDC_BEST));
                        break;
                    }
                    if ((g_drCustom.FIELD_BEEPVALUE1 < MIN_COMPARE) || 
                        (g_drCustom.FIELD_BEEPVALUE1 > MAX_COMPARE))
                    {
                            StrLToA(szMinRange, (Long)MIN_COMPARE);
                            StrLToA(szMaxRange, (Long)MAX_COMPARE);
                            FrmCustomAlert(IDA_RANGE_ERROR, "compare", 
                                szMinRange, szMaxRange);
                            FrmSetFocus(pForm, FrmGetObjectIndex(pForm, IDC_COMPARE_VALUE1));
                            break;
                    }
                    if ((g_drCustom.FIELD_BEEPVALUE2 < MIN_COMPARE) || 
                        (g_drCustom.FIELD_BEEPVALUE2 > MAX_COMPARE))
                    {
                            StrLToA(szMinRange, (Long)MIN_COMPARE);
                            StrLToA(szMaxRange, (Long)MAX_COMPARE);
                            FrmCustomAlert(IDA_RANGE_ERROR, "compare", 
                                szMinRange, szMaxRange);
                            FrmSetFocus(pForm, FrmGetObjectIndex(pForm, IDC_COMPARE_VALUE2));
                            break;
                    }
                    if ((g_drCustom.FIELD_SUCCESSVALUE < MIN_SUCCESS) || 
                        (g_drCustom.FIELD_SUCCESSVALUE > MAX_SUCCESS))
                    {
                            StrLToA(szMinRange, (Long)MIN_SUCCESS);
                            StrLToA(szMaxRange, (Long)MAX_SUCCESS);
                            FrmCustomAlert(IDA_RANGE_ERROR, "success", 
                                szMinRange, szMaxRange);
                            FrmSetFocus(pForm, FrmGetObjectIndex(pForm, IDC_SUCCESS_VALUE));
                            break;
                    }
                    if (StrLen(g_drCustom.szTitle) == 0)
                    {
						CreateTitle(&g_drCustom, g_drCustom.szTitle, MAX_TITLE_LEN+1);
                    }
                    SetCustomButton(&g_drCustom);
                }
                case IDC_CANCEL:
                    FrmReturnToForm(0);
                    ShowPage();
                    break;
            }
            handled = 1;
            break;

        case menuEvent:
            switch (event->data.menu.itemID)
            {
                case IDM_EDIT_KEYBOARD:
                    SysKeyboardDialog(kbdDefault);
                    break;
                case IDM_EDIT_COPY_ROLL:
                    CopyCustomRoll(&g_drPaste);
                    break;
                case IDM_EDIT_PASTE_ROLL:
                    PasteCustomRoll(&g_drPaste);
                    break;
            }
            handled = 1;
            break;
    }

    return handled;
}

void InitializeCustom ()
{
	static Boolean bInit = false;
	FormPtr pForm;

	pForm = FrmGetActiveForm();

	// Do the one time initialization 
	//  of the custom dialog here.
	if (!bInit)
	{
	    MemSet(&g_drPaste, sizeof(DieRoll), '\0');
		bInit = true;
	}

	// Do the every time initialization 
	//  of the custom dialog here.

	InitDynamicPopup (pForm, IDC_BEEP_TYPE1);
	InitDynamicPopup (pForm, IDC_BEEP_TYPE2);
}

void CopyCustomRoll (DieRollPtr dieRollPtr)
{
    StrCopy(dieRollPtr->szTitle, (CharPtr)MemHandleLock(hTitle));
    MemHandleUnlock(hTitle);
    
    dieRollPtr->FIELD_NUMBER = StrAToI((CharPtr)MemHandleLock(hNumber));
    MemHandleUnlock(hNumber);
    
    dieRollPtr->FIELD_DIE = StrAToI((CharPtr)MemHandleLock(hDie));
    MemHandleUnlock(hDie);
    
    dieRollPtr->FIELD_MODIFIER = StrAToI((CharPtr)MemHandleLock(hModifier));
    MemHandleUnlock(hModifier);
    
    dieRollPtr->FIELD_BEST = StrAToI((CharPtr)MemHandleLock(hBest));
    MemHandleUnlock(hBest);
    
    dieRollPtr->FIELD_BEEPVALUE1 = (Long)StrAToL((CharPtr)MemHandleLock(hCompare1));
    MemHandleUnlock(hCompare1);

    dieRollPtr->FIELD_BEEPVALUE2 = (Long)StrAToL((CharPtr)MemHandleLock(hCompare2));
    MemHandleUnlock(hCompare2);

    dieRollPtr->FIELD_SUCCESSVALUE = (Long)StrAToL((CharPtr)MemHandleLock(hSuccess));
    MemHandleUnlock(hSuccess);
}

void PasteCustomRoll (DieRollPtr dieRollPtr)
{
    FormPtr pForm;
    Char szTemp [32];
	CharPtr *pList;
	int i, iCount;

    pForm = FrmGetActiveForm();
    hTitle = SetField (pForm, IDC_TITLE, MAX_TITLE_LEN, dieRollPtr->szTitle);
    hNumber = SetField (pForm, IDC_NUMBER, MAX_NUMBER_LEN, 
        StrLToA(szTemp, (Long)dieRollPtr->FIELD_NUMBER));
    hDie = SetField (pForm, IDC_DIE, MAX_DIE_LEN,
        StrLToA(szTemp, (Long)dieRollPtr->FIELD_DIE));
    hModifier = SetField (pForm, IDC_MODIFIER, MAX_MODIFIER_LEN,
        StrLToA(szTemp, (Long)dieRollPtr->FIELD_MODIFIER));
    hBest = SetField (pForm, IDC_BEST, MAX_BEST_LEN,
        StrLToA(szTemp, (Long)dieRollPtr->FIELD_BEST));
    hCompare1 = SetField (pForm, IDC_COMPARE_VALUE1, MAX_COMPARE_LEN,
        StrLToA(szTemp, (Long)dieRollPtr->FIELD_BEEPVALUE1));
    hCompare2 = SetField (pForm, IDC_COMPARE_VALUE2, MAX_COMPARE_LEN,
        StrLToA(szTemp, (Long)dieRollPtr->FIELD_BEEPVALUE2));
    hSuccess = SetField (pForm, IDC_SUCCESS_VALUE, MAX_SUCCESS_LEN,
        StrLToA(szTemp, (Long)dieRollPtr->FIELD_SUCCESSVALUE));

	iCount = CreateSoundList (&pList);
	if (dieRollPtr->FIELD_BEEPTYPE1 >= iCount)
		dieRollPtr->FIELD_BEEPTYPE1 = 0;
	if (dieRollPtr->FIELD_BEEPTYPE2 >= iCount)
		dieRollPtr->FIELD_BEEPTYPE2 = 0;
	SetDynamicPopup(pForm, IDC_BEEP_TYPE1, pList [dieRollPtr->FIELD_BEEPTYPE1]);
	SetDynamicPopup(pForm, IDC_BEEP_TYPE2, pList [dieRollPtr->FIELD_BEEPTYPE2]);
	DeleteSoundList(&pList);

    FrmCopyLabel(pForm, IDC_COMPARE_TYPE1, 
        LstGetSelectionText(FrmGetObjectPtr(pForm, 
            FrmGetObjectIndex(pForm, IDC_COMPARE_LIST1)), 
            dieRollPtr->FIELD_BEEPCOMPARE1));
    FrmCopyLabel(pForm, IDC_COMPARE_TYPE2, 
        LstGetSelectionText(FrmGetObjectPtr(pForm, 
            FrmGetObjectIndex(pForm, IDC_COMPARE_LIST2)), 
            dieRollPtr->FIELD_BEEPCOMPARE2));
    FrmCopyLabel(pForm, IDC_SUCCESS_TYPE, 
        LstGetSelectionText(FrmGetObjectPtr(pForm, 
            FrmGetObjectIndex(pForm, IDC_SUCCESS_LIST)), 
            dieRollPtr->FIELD_SUCCESSCOMPARE));

    // Redraw the form.
    FrmDrawForm(pForm);
}

Int CreateSoundList (CharPtr **pList)
{
	VoidHand hRecord;
	Ptr pRecord;
	CharPtr pChar;
	Int i, iCount;

	iCount = 0;
	if (g_hRollEmDB)
	{
		if (DmNumRecords(g_hRollEmDB) > SOUNDS_RECORD)
		{
			hRecord = DmGetRecord(g_hRollEmDB, SOUNDS_RECORD);
			pChar = (CharPtr)MemHandleLock(hRecord);
			iCount = *((UIntPtr)pChar) + 1;

			*pList = (CharPtr*)MemPtrNew(sizeof(CharPtr) * (iCount + 1));
			(*pList)[iCount] = 0;
			(*pList)[0] = (CharPtr)MemPtrNew(sizeof(Char) * (MAX_TITLE_LEN + 1));
			StrCopy((*pList) [0], "None");

			// Moveit 
			pChar += sizeof(UInt);
			for (i=1; i<iCount; i++)
			{
				// Skip the sounds.
				while (((NotePtr)pChar)->uiDuration)
					pChar += sizeof(Note);

				// Move up.
				pChar += sizeof(Note);

				// Make and copy the title.
				(*pList) [i] = (CharPtr)MemPtrNew(sizeof(Char) * (MAX_TITLE_LEN + 1));
				StrCopy((*pList) [i], pChar);

				// Skip the titles.
				pChar += MAX_TITLE_LEN + 1;
			}

			MemHandleUnlock(hRecord); 
			DmReleaseRecord(g_hRollEmDB, SOUNDS_RECORD, false);  
		}
	}

	return iCount;
}

void DeleteSoundList (CharPtr **pList)
{
	Int i;

	i = 0;
	while ((*pList) [i])
	{
		MemPtrFree((*pList) [i]);
		i++;
	}
	MemPtrFree(*pList);
}
