#ifndef __ROLLEM_H
#define __ROLLEM_H      1

#ifdef __cplusplus
extern "C" {
#endif

//#define _DEBUG

#define ROLLEM_APPID			'RlEm'
#define ROLLEM_DBTYPE			'Data'

#define MIN_DIE                 2
#define MAX_DIE                 1000
#define MIN_NUMBER              1
#define MAX_NUMBER              1000
#define MIN_MODIFIER           -9999
#define MAX_MODIFIER            10000
#define MIN_BEST                0
#define MAX_BEST                (MAX_NUMBER-1)
#define MIN_COMPARE             0
#define MAX_COMPARE             1000000
#define MIN_SUCCESS             0
#define MAX_SUCCESS             1000

#define MIN_PAGES               1
#define MAX_PAGES               99

#define MAX_TITLE_LEN           15
#define MAX_DIE_LEN             4
#define MAX_NUMBER_LEN          4
#define MAX_MODIFIER_LEN        6
#define MAX_BEST_LEN            3
#define MAX_COMPARE_LEN         7
#define MAX_SUCCESS_LEN         7
#define MAX_TEMPSTRING_LEN		50
#define DEFAULT_PAGES           5
#define VERSION_NUMBER			110

#define IDC_BUTTON_FIRST        IDC_BUTTON_0
#define IDC_BUTTON_LAST         IDC_BUTTON_7
#define NUM_BUTTONS             ((IDC_BUTTON_LAST - IDC_BUTTON_FIRST) + 1)
#define ID2NUM(wId)             (wId - IDC_BUTTON_FIRST)
#define PAGE2REC(wPage)         (wPage+10)
#define PREFS_RECORD			0
#define RESULTS_RECORD			1
#define SOUNDS_RECORD			2
#define ROLLS_RECORD			3

#define FIELD_DIE				lField00
#define FIELD_NUMBER			lField01
#define FIELD_MODIFIER			lField02
#define FIELD_BEST				lField03
#define FIELD_BEEPTYPE1			lField04
#define FIELD_BEEPTYPE2			lField05
#define FIELD_BEEPCOMPARE1		lField06
#define FIELD_BEEPCOMPARE2		lField07
#define FIELD_SUCCESSCOMPARE	lField08
#define FIELD_BEEPVALUE1		lField09
#define FIELD_BEEPVALUE2		lField10
#define FIELD_SUCCESSVALUE		lField11
#define FIELD_MISC1				lField12
#define FIELD_MISC2				lField13
#define FIELD_MISC3				lField14
#define FIELD_MISC4				lField15
#define FIELD_MISC5				lField16
#define FIELD_MISC6				lField17
#define FIELD_MISC7				lField18
#define FIELD_MISC8				lField19
#define FIELD_MISC9				lField20
#define FIELD_MISC10			lField21
#define FIELD_MISC11			lField22
#define FIELD_MISC12			lField23
#define FIELD_MISC13			lField24

// ************************************************************* //
//                         Enumerations                          //
// ************************************************************* //

typedef enum 
{
    ComparisonEqual=0,
    ComparisonGreater,
    ComparisonLess,
    ComparisonGreaterEqual,
    ComparisonLessEqual,
    ComparisonNotEqual
} Comparison;

// ************************************************************* //
//                          Structures                           //
// ************************************************************* //

typedef struct _tagDieRoll
{
	Char szTitle [MAX_TITLE_LEN+1];
	Long lField00; //iDie
	Long lField01; //iNumber
	Long lField02; //iModifier
	Long lField03; //iBest
	Long lField04; //iBeepType1
	Long lField05; //iBeepType2
	Long lField06; //iBeepCompare1
	Long lField07; //iBeepCompare2
	Long lField08; //iSuccessCompare
	Long lField09; //lBeepValue1
	Long lField10; //lBeepValue2
	Long lField11; //lSuccessValue
	Long lField12; //lMisc1
	Long lField13; //lMisc2
	Long lField14; //lMisc3
	Long lField15; //lMisc4
	Long lField16; //lMisc5
	Long lField17; //lMisc6
	Long lField18; //lMisc7
	Long lField19; //lMisc8
	Long lField20; //lMisc9
	Long lField21; //lMisc10
	Long lField22; //lMisc11
	Long lField23; //lMisc12
	Long lField24; //lMisc13
} DieRoll;
typedef DieRoll *DieRollPtr;

// Prefs
typedef struct _tagPrefs
{
    Word wVersion;
    Word wTotalPages;
	Word wSaveRolls;
} Prefs;
typedef Prefs *PrefsPtr;

// Results
typedef struct _tagResults
{
    Word wCurrentPage;
    Word wCurrentButton;
	Long lLastResult;
} Results;
typedef Results *ResultsPtr;

typedef struct _tagNote
{
    UInt uiHertz;
    UInt uiDuration;
} Note;
typedef Note *NotePtr;
typedef NotePtr *NoteArray;

// ************************************************************* //
//                           Externs                             //
// ************************************************************* //

extern DmOpenRef g_hRollEmDB;
extern PrefsPtr g_pPrefs;

// ************************************************************* //
//                     Forward Declarations                      //
// ************************************************************* //

void GetCustomButton (DieRollPtr drPtr);
void SetCustomButton (DieRollPtr drPtr);

#ifdef __cplusplus
}
#endif

#endif
