#include "StdInc.h"
#include "RollEm.h"

#define TEXT_X			8	
#define TEXT_Y			20
#define TEXT_WIDTH		140
#define TEXT_HEIGHT		110
#define TEXT_SPACING	2

Int g_iRowListPos, g_iRowListRows, g_iRowListCols;

void InitRowList ();
void DrawRowList ();
void MoveRowList (Int iDirection);

Boolean RollsProc (EventPtr event)
{
    FormPtr pForm;
    Int handled = 0;

    switch (event->eType) 
    {
        case frmOpenEvent:
        {
            pForm = FrmGetActiveForm();
            FrmSetFocus(pForm, FrmGetObjectIndex(pForm, IDC_OK));
            FrmDrawForm(pForm);
			InitRowList();
			DrawRowList();
            handled = 1;
            break;
        }
        case ctlSelectEvent:
		{
            switch (event->data.ctlEnter.controlID)
            {
                case IDC_OK:
                    FrmReturnToForm(0);
                    break;
            }
            handled = 1;
            break;
		}
		case ctlRepeatEvent:
		{
            switch (event->data.ctlEnter.controlID)
            {
                case IDC_PREV:
                    MoveRowList(-1);
                    break;
                case IDC_NEXT:
                    MoveRowList(1);
                    break;
            }
            break;
		}
		case keyDownEvent:
		{
            switch (event->data.keyDown.chr)
            {
                case pageUpChr:
                    MoveRowList(-1);
                    break;
                case pageDownChr:
                    MoveRowList(1);
                    break;
            }
            break;
		}
	}

    return handled;
}

void InitRowList ()
{
	// Modify the lists to look better.
	SortList();
	ReverseList();

	g_iRowListPos = 0;
	g_iRowListRows = (TEXT_HEIGHT - (TEXT_SPACING*0)) / FntCharHeight();
	g_iRowListCols = 1;

	MoveRowList(0);
}

void DrawRowList ()
{
    Int iCurrentX=TEXT_X + TEXT_SPACING, iCurrentY=TEXT_Y, i;
    Int iCharHeight, iListSize, iEnd;
	Long lValue;
    Char szText [50];
    RectangleType rtRect;

    iCharHeight = FntCharHeight();
	iListSize = GetCurrentSizeList();

	// Figure out the ending point.
	iEnd = g_iRowListPos + g_iRowListRows;
	if (iEnd > iListSize)
		iEnd = iListSize;

    rtRect.topLeft.x = TEXT_X;
    rtRect.topLeft.y = TEXT_Y;
    rtRect.extent.x = TEXT_WIDTH;
    rtRect.extent.y = TEXT_HEIGHT;

	WinDrawRectangleFrame(rectangleFrame, &rtRect);

    rtRect.topLeft.x++;
    rtRect.topLeft.y++;
    rtRect.extent.x -= 2;
    rtRect.extent.y -= 2;

	WinEraseRectangle(&rtRect, 0);

    for (i=g_iRowListPos; i<iEnd; i++)
    {
		lValue = GetElementList(i);
		StrLToA(szText, lValue);
		WinDrawChars(szText, StrLen(szText), iCurrentX, iCurrentY);
		iCurrentY += iCharHeight;
    }
}

void MoveRowList (Int iDirection)
{
	FormPtr pForm;
	Word wUpIndex, wDownIndex;
	Boolean bScrollUp, bScrollDown;
	Int iNewPos;

	if (iDirection != 0)
	{
		iNewPos = g_iRowListPos + iDirection;

		if ((iNewPos + g_iRowListRows) > GetCurrentSizeList())
			iNewPos = GetCurrentSizeList() - g_iRowListRows;
		if (iNewPos < 0)
			iNewPos = 0;

		if (iNewPos != g_iRowListPos)
		{
			g_iRowListPos = iNewPos;
			DrawRowList();
		}
	}

	bScrollUp = (g_iRowListPos != 0);
	bScrollDown = ((g_iRowListPos + g_iRowListRows) < GetCurrentSizeList());

    pForm = FrmGetActiveForm();
	wUpIndex = FrmGetObjectIndex(pForm, IDC_PREV);
	wDownIndex = FrmGetObjectIndex(pForm, IDC_NEXT);
	FrmUpdateScrollers(pForm, wUpIndex, wDownIndex, bScrollUp, bScrollDown); 
}
